﻿//   kd_Starglow v0.3
//   This script adds Starglow effect to the selected layer.
//    Original idea by @ttsukune and script by @takumi_kashima

MakeStarglow();

function MakeStarglow(){
    var Layers = app.project.activeItem;
	if(Layers.selectedLayers.length != 1){
	    alert("Please select only one layer.");
        return;
     }
    var layer = Layers.selectedLayers[0];
    var cnt = parseInt(prompt("いくつ複製しますか？", "8"));
    if(cnt<0){
            alert("Please input a positive number.");
            return;
     }

    // Make a Null Object as Control Layer
    var selectComp = Layers.selectedLayers[0].containingComp;
	var myNull = selectComp.layers.addNull();
	myNull.startTime = layer.startTime;
    myNull.name = "Starglow Control"
    
    e1 = myNull.Effects.addProperty("スライダー制御");
    e1.property("スライダー").setValue(50);
    e1.name = "長さ";
    
    e2 = myNull.Effects.addProperty("角度制御");
    e2.property("角度").setValue(0);
    e2.name = "角度";
     
    e3 = myNull.Effects.addProperty("スライダー制御");
    e3.property("スライダー").setValue(100);
    e3.name = "カラー - 色相";   
     
    e4 = myNull.Effects.addProperty("スライダー制御");
    e4.property("スライダー").setValue(0);
    e4.name = "カラー - オフセット";   
          
    e5 = myNull.Effects.addProperty("スライダー制御");
    e5.property("スライダー").setValue(-47);
    e5.name = "カラー - 明度";   
 
    e6 = myNull.Effects.addProperty("スライダー制御");
    e6.property("スライダー").setValue(77);
    e6.name = "カラー - 彩度";   
  
    e7 = myNull.Effects.addProperty("スライダー制御");
    e7.property("スライダー").setValue(30);
    e7.name = "グロー - しきい値";   
      
    e8 = myNull.Effects.addProperty("スライダー制御");
    e8.property("スライダー").setValue(10);
    e8.name = "グロー - 半径";   
    
    e9 = myNull.Effects.addProperty("スライダー制御");
    e9.property("スライダー").setValue(0.2);
    e9.name = "グロー - 強度";   

    // Duplicate and add effects
    for(var i=0; i<cnt; i++){
            duplicatedLayer = layer.duplicate();
                 
            e1 = duplicatedLayer.Effects.addProperty("角度制御");
            var r = (360/cnt)*i;
            e1.property("角度").setValue(r);
 
            e2 = duplicatedLayer.Effects.addProperty("ブラー(方向）");
            e2.property("方向").expression = "thisComp.layer('Starglow Control').effect('角度')('角度') + effect('角度制御')('角度');";
            e2.property("ブラーの長さ").expression = "thisComp.layer('Starglow Control').effect('長さ')('スライダー')";

            e3 = duplicatedLayer.Effects.addProperty("色相/彩度");
            e3.property("色彩の統一").setValue(true);
            e3.property("色相").expression = "effect('角度制御')('角度')*(thisComp.layer('Starglow Control').effect('カラー - 色相')('スライダー')/100) + thisComp.layer('Starglow Control').effect('カラー - オフセット')('スライダー')";
            e3.property("彩度").expression = "thisComp.layer('Starglow Control').effect('カラー - 彩度')('スライダー')";
            e3.property("明度").expression = "thisComp.layer('Starglow Control').effect('カラー - 明度')('スライダー')";
           
            e4 = duplicatedLayer.Effects.addProperty("グロー");
            e4.property("グローしきい値").expression = "thisComp.layer('Starglow Control').effect('グロー - しきい値')('スライダー')";
            e4.property("グロー半径").expression = "thisComp.layer('Starglow Control').effect('グロー - 半径')('スライダー')";
            e4.property("グロー強度").expression = "thisComp.layer('Starglow Control').effect('グロー - 強度')('スライダー')";
           
            duplicatedLayer("Anchor Point").expression = "deg=-effect('ブラー(方向）')('方向')*3.141592/180;\nrad=effect('ブラー(方向）')('ブラーの長さ')*0.5;\n[transform.anchorPoint[0]+Math.sin(deg)*rad,transform.anchorPoint[1]+Math.cos(deg)*rad]";
            duplicatedLayer.blendingMode = BlendingMode.ADD;
            duplicatedLayer.name = "Starglow" + (i+1) + "_" + layer.name;
		   duplicatedLayer.parent = layer;
    }
    return;
}

